/***********************************************************************/
/*								       */
/*  FILE		:Main.c or Main.cpp			       */
/*  DATE		:Tue, Oct 31, 2006			       */
/*  DESCRIPTION :Main Program					       */
/*  CPU TYPE	:						       */
/*								       */
/*  NOTE:THIS IS A TYPICAL EXAMPLE.				       */
/*								       */
/***********************************************************************/
//#include "typedefine.h"
#ifdef __cplusplus
//#include <ios>			// Remove the comment when you use ios
//_SINT ios_base::Init::init_cnt;	// Remove the comment when you use ios
#endif

void main(void);
#ifdef __cplusplus
extern "C" {
void abort(void);
}
#endif

#include "iodefine.h"

extern void SCI1_INIT(void);
extern int SCI1_PRINTF(const char *format, ...);
extern int SCI1_SEND_CHECK(void);


extern void SCI9_INIT(void);
extern int SCI9_PRINTF(const char *format, ...);
extern int SCI9_SEND_CHECK(void);


#define Kp 1.0;

//O[oϐ̒`
int r_sen,l_sen,fr_sen,fl_sen;		//EZŤݒl
int r_wall_ref = 0;			//EǂƂ̌ZTŏl
int l_wall_ref = 0;			//ǂƂ̌ZTŏl

int fr_wall_ref = 0;			//EOǂƂ̌ZTŏl
int fl_wall_ref = 0;			//OǂƂ̌ZTŏl

int r_sen_ref = 0;			//ɒủEZTt@X
int l_sen_ref = 0;			//ɒu̍ZTt@X
int start_flag = 0;			//{bg̑sJntO
volatile unsigned int step_r;		//Ẽ[^̃pX
volatile unsigned int step_l;		//̃[^̃pX


#define UNKNOWN 0
#define NOWALL 2
#define WALL 3

typedef enum {
	north = 0,
	east =1,
	south=2,
	west=3
} t_direction;


typedef struct {
	unsigned char north:2;
	unsigned char east:2;
	unsigned char south:2;
	unsigned char west:2;
}t_wall;





void cmt_int(void){			//CMT̊荞
	int i;
	int sen_diff;			//΍pϐ
	int r_wall_flag;		//Eɕǂ邩ǂ̃tO
	int l_wall_flag;		//ɕǂ邩ǂ̃tO
	
	float control_motor;
	
	//A/DϊJn
	//EZTA/Dϊ
	PORT0.PODR.BIT.B5 = 1;		//EZTpLEDJn
	for(i = 0; i < 300; i++);	//gWX^܂ő҂
	S12AD.ADANS0.BIT.ANS0=0x0040;	//AN006(ẼZT)
	S12AD.ADCSR.BIT.ADST=1;		//ADϊJn
	while(S12AD.ADCSR.BIT.ADST);	//ADϊI܂ő҂
	PORT0.PODR.BIT.B5 = 0;		//EZTpLED	
	r_sen = S12AD.ADDR6;
	//ZTA/Dϊ
	PORT5.PODR.BIT.B4 = 1;		//ZTpLEDsJn
	for(i = 0; i < 300; i++);	//gWX^܂ő҂
	S12AD.ADANS0.BIT.ANS0=0x0004;	//AN002(̃ZT)
	S12AD.ADCSR.BIT.ADST=1;		//ADϊJn
	while(S12AD.ADCSR.BIT.ADST);	//ADϊI܂ő҂
	PORT5.PODR.BIT.B4 = 0;		//ZTpLED
	l_sen = S12AD.ADDR2;
	//EOZTA/Dϊ
	PORTB.PODR.BIT.B5 = 1;		//EOZTpLEDJn
	for(i = 0; i < 300; i++);	//gWX^܂ő҂
	S12AD.ADANS0.BIT.ANS0=0x0200;	//AN009(EÕZT)
	S12AD.ADCSR.BIT.ADST=1;		//ADϊJn
	while(S12AD.ADCSR.BIT.ADST);	//ADϊI܂ő҂
	PORTB.PODR.BIT.B5 = 0;		//EOZTpLED	
	fr_sen = S12AD.ADDR9;
	//OZTA/Dϊ
	PORT2.PODR.BIT.B7 = 1;		//OZTpLEDsJn
	for(i = 0; i < 300; i++);	//gWX^܂ő҂
	S12AD.ADANS0.BIT.ANS0=0x0010;	//AN004(ÕZT)
	S12AD.ADCSR.BIT.ADST=1;		//ADϊJn
	while(S12AD.ADCSR.BIT.ADST);	//ADϊI܂ő҂
	PORT2.PODR.BIT.B7 = 0;		//OZTpLED
	fl_sen = S12AD.ADDR4;
	
	
	if(start_flag == 1){		// 1ȂΎp
		//EɕǂΉELED_
		//ǂȂLED
		if((r_wall_ref+20)/2 < r_sen){
			PORTA.PODR.BIT.B0 = 1;
			r_wall_flag = 1;
		}else{
			PORTA.PODR.BIT.B0 = 0;
			r_wall_flag = 0;
		}
		
		//ɕǂΉELED_
		//ǂȂLED
		if((l_wall_ref+20)/2 < l_sen){
			PORTB.PODR.BIT.B0 = 1;
			l_wall_flag = 1;
		}else{
			PORTB.PODR.BIT.B0 = 0;
			l_wall_flag = 0;
		}		

		//EOɕǂΉEOLED_
		//ǂȂLED
		if( fr_wall_ref < fr_sen){
			PORTA.PODR.BIT.B6 = 1;
		}else{
			PORTA.PODR.BIT.B6 = 0;
		}
		
		//Oɕǂ΍OLED_
		//ǂȂLED
		if( fl_wall_ref < fl_sen){
			PORTA.PODR.BIT.B4 = 1;
		}else{
			PORTA.PODR.BIT.B4 = 0;
		}		
		
		
		//̏Őn؂ւ
		//ɕǂꍇ
		if(r_wall_flag == 1 && l_wall_flag == 1){
			sen_diff = r_sen - l_sen;
		}
		//Eǂꍇ
		else if(r_wall_flag == 1 && l_wall_flag == 0){
			sen_diff = 2 * (r_sen - r_sen_ref);	
		}//ǂꍇ
		else if(r_wall_flag == 0 && l_wall_flag == 1){
			sen_diff = -2 * (l_sen - l_sen_ref);	
		}//ɕǂȂꍇ
		else if(r_wall_flag == 0 && l_wall_flag == 0){
			sen_diff = 0;		
		}
		
		//P̐ʂ̌vZ
		control_motor =(float)sen_diff * Kp;
		//[^ɏo

		MTU3.TGRA = (unsigned short)(6297 - control_motor);
		MTU4.TGRA = (unsigned short)(6297 + control_motor);
		
	}else{
		MTU3.TGRA = 30000;
		MTU4.TGRA = 30000;
	}
	

}//܂Ŋ荞ݏ




void main(void)
{
	int j,k,x,y;
	t_wall	wall[16][16];		//H}bv
	unsigned char map[16][16];	//}bv
	unsigned char little;
	t_direction mydir,next_dir;
	char wall_write[4];
	char change_flag;
	
//
//	function̏
//
// clock setting
	SYSTEM.PRCR.WORD   = 0xa50b;	//NbN\[XI̕ی̉
	SYSTEM.PLLCR.WORD  = 0x0F00;	// PLL {~16 1 (12.000MHz * 16 = 192MHz)
	SYSTEM.PLLCR2.BYTE = 0x00;	// PLL ENABLE
	SYSTEM.SCKCR.LONG  = 0x21C21211;//FCK1/4 ICK1/2 BCLK~ SDCLK~ BCK1/4 PCLKA1/2 PCLKB1/4
	SYSTEM.SCKCR2.WORD = 0x0032;	// UCLK1/4 IEBCK1/4
	SYSTEM.BCKCR.BYTE  = 0x01;	// BCLK = 1/2
	SYSTEM.SCKCR3.WORD = 0x0400;	//PLLHI
// IO setting
	PORTB.PDR.BIT.B0 = 1;		//LED0
	PORTA.PDR.BIT.B6 = 1;		//LED1
	PORTA.PDR.BIT.B4 = 1;		//LED2
	PORTA.PDR.BIT.B0 = 1;		//LED3
	PORT1.PDR.BIT.B5 = 1;		//motor Enable
	PORT1.PODR.BIT.B5=0;		//Motor Power Off
	PORT1.PDR.BIT.B5 = 1;		//motor Enable
	PORTC.PDR.BIT.B5 = 1;		//Rmotor CW/CCW
	PORTC.PDR.BIT.B6 = 1;		//Lmotor CW/CCW
//CMT setting
	SYSTEM.PRCR.WORD = 0xA502;
	MSTP(CMT0) = 0;
	SYSTEM.PRCR.WORD = 0xA500;	
	//CMT0͐䊄荞ݗp^C}ƂĎgp
	CMT0.CMCR.BIT.CKS=1;		// PCLK/32 1.5MHz
	CMT0.CMCR.BIT.CMIE=1;		//荞݂
	CMT0.CMCNT=0;			//JE^[̃NA
	CMT0.CMCOR=1500-1;		//1kHz
	IEN(CMT0,CMI0) = 1;		//荞ݗv 
	IPR(CMT0,CMI0) = 15;		//荞ݗDx 15ō
	IR(CMT0,CMI0)=0;		//荞݃Xe[^tONA
	CMT.CMSTR0.BIT.STR0=1;		//JEgX^[g
	
	//ZTpLED̃sݒ
	PORT5.PDR.BIT.B4 = 1;		//SLED_L
	PORT0.PDR.BIT.B5 = 1;		//SLED_R
	PORT2.PDR.BIT.B7 = 1;		//SLED_FL
	PORTB.PDR.BIT.B5 = 1;		//SLED_FR
	
	//A/Dϊp̃sݒ
	SYSTEM.PRCR.WORD = 0xA502;
	MSTP_S12AD = 0;
	SYSTEM.PRCR.WORD = 0xA500;
	PORTE.PMR.BIT.B0=1;		//A/D
	PORTE.PMR.BIT.B1=1;		//A/D
	PORT4.PMR.BIT.B4=1;		//A/D
	PORT4.PMR.BIT.B6=1;		//A/D
	PORT4.PMR.BIT.B2=1;		//A/D
	MPC.PWPR.BYTE=0x00;		//veNg
	MPC.PWPR.BYTE=0x40;		//veNg
	MPC.P46PFS.BIT.ASEL=1;		//A/D SEN_R
	MPC.P42PFS.BIT.ASEL=1;		//A/D SEN_L
	MPC.PWPR.BYTE=0x80;		//veNg쓮
	
	//A/Dϊ(ftHgŃVO[h)
	//S12AD.ADCSR.BYTE = 0x0c;	//A/DϊNbNPCLK(48MHz)
	S12AD.ADCSR.BIT.CKS = 3;	//A/Dϊ̃NbNPCLK1(48MHz)ɐݒ
	S12AD.ADANS0.WORD = 0x0200;	//A/DϊAN009̂݋
	S12AD.ADCSR.BIT.ADCS = 0;	//VOXL[hɐݒ
	
//port select
	MPC.PWPR.BIT.B0WI=0;
	MPC.PWPR.BIT.PFSWE=1;
	MPC.PB3PFS.BIT.PSEL=1;		//MTIOC0A buzzer
	MPC.P17PFS.BIT.PSEL=1;		//MTIOC3A Rmotor PWM for clock
	MPC.PE2PFS.BIT.PSEL=1;		//MTIOC4A Lmotor PWM for clock
	MPC.PWPR.BYTE=0x80;
	PORTB.PMR.BIT.B3=1;		//SP PWM
	PORT1.PMR.BIT.B7=1;		//EPWM
	PORTE.PMR.BIT.B2=1;		//PWM
//MTU setting
	SYSTEM.PRCR.WORD = 0xA502;
	MSTP(MTU) = 0;			//MTUW[ON
  	SYSTEM.PRCR.WORD = 0xA500;	
	MTU.TSTR.BYTE=0;		//^C}Xgbv
	//E[^pMTUݒ
	MTU3.TCR.BIT.TPSC=2;		//PCLK/16 3MHz
	MTU3.TCR.BIT.CCLR=1;		//PWM TGRÃRyA}b`TCNTNA
	MTU3.TIORH.BIT.IOA=1;		//o0yA}b`1o
	MTU3.TIORH.BIT.IOB=2;		//o0RyA}b`0o
	MTU3.TGRA = 6297;		//3000000/((180/0.377) - 1) = 6297
	MTU3.TGRB = 50;
	MTU3.TGRC = 6297;
	MTU3.TMDR.BIT.MD=2;		//PWM1
	MTU3.TMDR.BIT.BFA = 1;		//obt@[[hɐݒ
	MTU3.TIER.BIT.TGIEB = 1;	//GRBRyA}b`ł̊荞݋
	IEN(MTU3,TGIB3) = 1;		//荞ݗv 
	IPR(MTU3,TGIB3) = 13;		//荞ݗDx_ɐݒ
	IR(MTU3,TGIB3)=0;		//荞݃Xe[^tONA
	//[^pMTUݒ
	MTU.TOER.BIT.OE4A=1;		//MTUo͒[qo͋
	MTU4.TCR.BIT.TPSC=2;		//PCLK/16 3MHz
	MTU4.TCR.BIT.CCLR=1;		//PWM TGRÃRyA}b`TCNTNA
	MTU4.TIORH.BIT.IOA=1;		//o0yA}b`1o
	MTU4.TIORH.BIT.IOB=2;		//o0RyA}b`0o
	MTU4.TGRA = 6297;
	MTU4.TGRB = 50;
	MTU4.TGRC = 6297;
	MTU4.TMDR.BIT.MD=2;		//PWM1
	MTU4.TMDR.BIT.BFA = 1;		//obt@[[hɐݒ
	MTU4.TIER.BIT.TGIEB = 1;	//GRBRyA}b`ł̊荞݋
	IEN(MTU4,TGIB4) = 1;		//荞ݗv 
	IPR(MTU4,TGIB4) = 12;		//荞ݗDx_ɐݒ
	IR(MTU4,TGIB4)=0;		//荞݃Xe[^tONA
	
	SCI9_INIT();			//SCȈ
	SCI9_PRINTF("Hello World\n\r");

//
//	ZT̖ڕWl̏
//
	//EǃZT̃t@X擾(ԑ̂񂹂ɂ)
	PORTA.PODR.BIT.B0 = 1;		//ELED3_
	while(PORTC.PIDR.BIT.B3 == 1);	//^񒆂̃XCb`܂ő҂
	r_wall_ref = r_sen;		//Eǂ̃ZTt@Xl擾
	for(j = 0; j < 3; j++){
		PORTB.PODR.BIT.B0 = 1;	//LED0 _
		PORTA.PODR.BIT.B6 = 1;	//LED1 
		PORTA.PODR.BIT.B4 = 1;	//LED2
		PORTA.PODR.BIT.B0 = 1;	//LED3
		for(k = 0; k < 1000000; k++ );
		PORTB.PODR.BIT.B0 = 0;	//LED0 
		PORTA.PODR.BIT.B6 = 0;	//LED1
		PORTA.PODR.BIT.B4 = 0;	//LED2
		PORTA.PODR.BIT.B0 = 0;	//LED3
		for(k = 0; k < 1000000; k++ );
	}
		
	//ǃZT̃t@X擾(ԑ̂E񂹂ɂ)
	PORTB.PODR.BIT.B0 = 1;		//LED0_
	while(PORTC.PIDR.BIT.B3 == 1);	//^񒆂̃XCb`܂ő҂
	l_wall_ref = l_sen;		//ǂ̃ZTt@Xl擾
	for(j = 0; j < 3; j++){
		PORTB.PODR.BIT.B0 = 1;	//LED0 _
		PORTA.PODR.BIT.B6 = 1;	//LED1 
		PORTA.PODR.BIT.B4 = 1;	//LED2
		PORTA.PODR.BIT.B0 = 1;	//LED3
		for(k = 0; k < 1000000; k++ );
		PORTA.PODR.BIT.B6 = 0;	//LED0 
		PORTB.PODR.BIT.B0 = 0;	//LED1
		PORTA.PODR.BIT.B4 = 0;	//LED2
		PORTA.PODR.BIT.B0 = 0;	//LED3
		for(k = 0; k < 1000000; k++ );
	}

	
	
	//ɒu̍EǃZT̃t@X擾(ԑ̂𒆉ɒu)
	PORTA.PODR.BIT.B6 = 1;		//^񒆂LED1_
	PORTA.PODR.BIT.B4 = 1;		//^񒆂LED2_
	while(PORTC.PIDR.BIT.B3 == 1);	//^񒆂̃XCb`܂ő҂
	l_sen_ref = l_sen;		//ǃZT̒l擾
	r_sen_ref = r_sen;		//EǃZT̒l擾
	fr_wall_ref = fr_sen;
	fl_wall_ref = fl_sen;
	for(j = 0; j < 3; j++){
		PORTB.PODR.BIT.B0 = 1;	//LED0 _
		PORTA.PODR.BIT.B6 = 1;	//LED1
		PORTA.PODR.BIT.B4 = 1;	//LED2
		PORTA.PODR.BIT.B0 = 1;	//LED3
		for(k = 0; k < 1000000; k++ );
		PORTB.PODR.BIT.B0 = 0;	//LED0 
		PORTA.PODR.BIT.B6 = 0;	//LED1
		PORTA.PODR.BIT.B4 = 0;	//LED2
		PORTA.PODR.BIT.B0 = 0;	//LED3
		for(k = 0; k < 1000000; k++ );
	}

	PORTA.PODR.BIT.B0 = 1;		//ELED3_
	PORTB.PODR.BIT.B0 = 1;		//LED0_	
	while(PORTC.PIDR.BIT.B3 == 1);	//^񒆂̃XCb`܂ő҂

	
//
//	@ŒT
//		
	start_flag = 1;				//p
	
	PORT1.PODR.BIT.B5 =1 ;			//Motor Power ON
	for(k = 0; k < 1000000; k++ );		//㎥ł͈肵Ȃ̂ŏ҂
	
//H̕Ǐ	
	for(x=0;x<16;x++){
		for(y=0;y<16;y++){
			wall[x][y].north = wall[x][y].east = wall[x][y].south = wall[x][y].west = UNKNOWN;
		}
	}
	
//ƍW̏
	mydir=north;
	x=0;
	y=0;
	
	
//90mmi
	PORTC.PODR.BIT.B5 =0 ;			//Forward
	PORTC.PODR.BIT.B6 =0 ;			//Forward
	step_r=step_l=0;			//step̏
	MTU.TSTR.BIT.CST3 = 1;			//^C}X^[g
	MTU.TSTR.BIT.CST4 = 1;			//^C}X^[g
	while( (step_r + step_l) < 477);

	
	y++;//90mmOɐi񂾂̂yW+1Z	
	
	
	while( (x != 3) || (y !=3) ){		//S[Wx=3,y=3ɂȂ܂ō@ŒT
		
	//ǂZbg
		wall_write[mydir] = ((fl_wall_ref > fl_sen) || (fr_wall_ref > fr_sen)) ? NOWALL: WALL;
		wall_write[(mydir+1)%4] = ((r_wall_ref+20)/2 > r_sen ) ? NOWALL : WALL ;
		wall_write[(mydir+2)%4] = NOWALL;
		wall_write[(mydir+3)%4] = ((l_wall_ref+20)/2 > l_sen ) ? NOWALL : WALL ;
		wall[x][y].north = wall_write[0];
		wall[x][y].east = wall_write[1];
		wall[x][y].south = wall_write[2];
		wall[x][y].west = wall_write[3];
		if(y < 15) wall[x][y+1].south = wall_write[0];
		if(x < 15) wall[x+1][y].west = wall_write[1];
		if(y > 0 ) wall[x][y-1].north = wall_write[2];
		if(x > 0 ) wall[x-1][y].east = wall_write[3];

	//ǂ̏Ԃ玟ɐiޕ߂
		if( mydir == north ){//isk
			if( wall[x][y].west == NOWALL){
				//90mmi
				start_flag = 1;				//p
				PORTC.PODR.BIT.B5 =0 ;			//Forward
				PORTC.PODR.BIT.B6 =0 ;			//Forward
				step_r=step_l=0;			//step̏
				MTU.TSTR.BIT.CST3 = 1;			//^C}X^[g
				MTU.TSTR.BIT.CST4 = 1;			//^C}X^[g
				while( (step_r + step_l) < 477);
				MTU.TSTR.BIT.CST3 = 0;			//PWM~
				MTU.TSTR.BIT.CST4 = 0;			//PWM~
			
				//90x
				start_flag = 0;				//pȂ
				for(k = 0; k < 1000000; k++ );		//OɊ[gȂȂ܂ł܂
				PORTC.PODR.BIT.B5 =0 ;			//Forward
				PORTC.PODR.BIT.B6 =1 ;			//Backward
				step_r=step_l=0;			//step̏
				MTU.TSTR.BIT.CST3 = 1;			//^C}X^[g
				MTU.TSTR.BIT.CST4 = 1;			//^C}X^[g
				while( (step_r + step_l) < 270);
				MTU.TSTR.BIT.CST3 = 0;			//PWM~
				MTU.TSTR.BIT.CST4 = 0;			//PWM~
				for(k = 0; k < 1000000; k++ );		//OɊ[gȂȂ܂ł܂

				//90mmi
				start_flag = 1;				//p
				PORTC.PODR.BIT.B5 =0 ;			//Forward
				PORTC.PODR.BIT.B6 =0 ;			//Forward
				step_r=step_l=0;			//step̏
				MTU.TSTR.BIT.CST3 = 1;			//^C}X^[g
				MTU.TSTR.BIT.CST4 = 1;			//^C}X^[g
				while( (step_r + step_l) < 477);
				
				x--;					//W1ɐi߂
				mydir=west;				//
				
			}else if( wall[x][y].north == NOWALL){
				//180mmi
				start_flag = 1;				//p
				PORTC.PODR.BIT.B5 =0 ;			//Forward
				PORTC.PODR.BIT.B6 =0 ;			//Forward
				step_r=step_l=0;			//step̏
				MTU.TSTR.BIT.CST3 = 1;	//^C}X^[g
				MTU.TSTR.BIT.CST4 = 1;	//^C}X^[g
				while( (step_r + step_l) < 954);
				
				y++;					//W1kɐi߂

				
			}else if(wall[x][y].east == NOWALL){
				//90mmi
				start_flag = 1;				//p
				PORTC.PODR.BIT.B5 =0 ;			//Forward
				PORTC.PODR.BIT.B6 =0 ;			//Forward
				step_r=step_l=0;			//step̏
				MTU.TSTR.BIT.CST3 = 1;			//^C}X^[g
				MTU.TSTR.BIT.CST4 = 1;			//^C}X^[g
				while( (step_r + step_l) < 477);
				MTU.TSTR.BIT.CST3 = 0;			//PWM~
				MTU.TSTR.BIT.CST4 = 0;			//PWM~

				//E90x
				start_flag = 0;				//pȂ
				for(k = 0; k < 1000000; k++ );		//OɊ[gȂȂ܂ł܂
				PORTC.PODR.BIT.B5 =1 ;			//Backward
				PORTC.PODR.BIT.B6 =0 ;			//Forward
				step_r=step_l=0;			//step̏
				MTU.TSTR.BIT.CST3 = 1;			//^C}X^[g
				MTU.TSTR.BIT.CST4 = 1;			//^C}X^[g
				while( (step_r + step_l) < 270);
				MTU.TSTR.BIT.CST3 = 0;			//PWM~
				MTU.TSTR.BIT.CST4 = 0;			//PWM~
				for(k = 0; k < 1000000; k++ );		//OɊ[gȂȂ܂ł܂

				//90mmi
				start_flag = 1;				//p
				PORTC.PODR.BIT.B5 =0 ;			//Forward
				PORTC.PODR.BIT.B6 =0 ;			//Forward
				step_r=step_l=0;			//step̏
				MTU.TSTR.BIT.CST3 = 1;			//^C}X^[g
				MTU.TSTR.BIT.CST4 = 1;			//^C}X^[g
				while( (step_r + step_l) < 477);
				
				x++;					//W1ɐi߂
				mydir=east;				//

			}else{
				//90mmi
				start_flag = 1;				//p
				PORTC.PODR.BIT.B5 =0 ;			//Forward
				PORTC.PODR.BIT.B6 =0 ;			//Forward
				step_r=step_l=0;			//step̏
				MTU.TSTR.BIT.CST3 = 1;			//^C}X^[g
				MTU.TSTR.BIT.CST4 = 1;			//^C}X^[g
				while( (step_r + step_l) < 477);
				MTU.TSTR.BIT.CST3 = 0;			//PWM~
				MTU.TSTR.BIT.CST4 = 0;			//PWM~
		
				//E180x
				start_flag = 0;				//pȂ
				for(k = 0; k < 1000000; k++ );		//OɊ[gȂȂ܂ł܂
				PORTC.PODR.BIT.B5 =1 ;			//Backward
				PORTC.PODR.BIT.B6 =0 ;			//Forward
				step_r=step_l=0;			//step̏
				MTU.TSTR.BIT.CST3 = 1;			//^C}X^[g
				MTU.TSTR.BIT.CST4 = 1;			//^C}X^[g
				while( (step_r + step_l) < 540);
				MTU.TSTR.BIT.CST3 = 0;			//PWM~
				MTU.TSTR.BIT.CST4 = 0;			//PWM~
				for(k = 0; k < 1000000; k++ );		//OɊ[gȂȂ܂ł܂

				//90mmi
				start_flag = 1;				//p
				PORTC.PODR.BIT.B5 =0 ;			//Forward
				PORTC.PODR.BIT.B6 =0 ;			//Forward
				step_r=step_l=0;			//step̏
				MTU.TSTR.BIT.CST3 = 1;			//^C}X^[g
				MTU.TSTR.BIT.CST4 = 1;			//^C}X^[g
				while( (step_r + step_l) < 477);

				y--;					//W1ɐi߂
				mydir=south;				//

				
			}
		}else if( mydir == east ){//is
			if( wall[x][y].north == NOWALL){
				//90mmi
				start_flag = 1;				//p
				PORTC.PODR.BIT.B5 =0 ;			//Forward
				PORTC.PODR.BIT.B6 =0 ;			//Forward
				step_r=step_l=0;			//step̏
				MTU.TSTR.BIT.CST3 = 1;			//^C}X^[g
				MTU.TSTR.BIT.CST4 = 1;			//^C}X^[g
				while( (step_r + step_l) < 477);
				MTU.TSTR.BIT.CST3 = 0;			//PWM~
				MTU.TSTR.BIT.CST4 = 0;			//PWM~
			
				//90x
				start_flag = 0;				//pȂ
				for(k = 0; k < 1000000; k++ );		//OɊ[gȂȂ܂ł܂
				PORTC.PODR.BIT.B5 =0 ;			//Forward
				PORTC.PODR.BIT.B6 =1 ;			//Backward
				step_r=step_l=0;			//step̏
				MTU.TSTR.BIT.CST3 = 1;			//^C}X^[g
				MTU.TSTR.BIT.CST4 = 1;			//^C}X^[g
				while( (step_r + step_l) < 270);
				MTU.TSTR.BIT.CST3 = 0;			//PWM~
				MTU.TSTR.BIT.CST4 = 0;			//PWM~
				for(k = 0; k < 1000000; k++ );		//OɊ[gȂȂ܂ł܂

				//90mmi
				start_flag = 1;				//p
				PORTC.PODR.BIT.B5 =0 ;			//Forward
				PORTC.PODR.BIT.B6 =0 ;			//Forward
				step_r=step_l=0;			//step̏
				MTU.TSTR.BIT.CST3 = 1;			//^C}X^[g
				MTU.TSTR.BIT.CST4 = 1;			//^C}X^[g
				while( (step_r + step_l) < 477);

				y++;					//W1kɐi߂
				mydir=north;				//k

				
			}else if( wall[x][y].east == NOWALL){
				//180mmi
				start_flag = 1;				//p
				PORTC.PODR.BIT.B5 =0 ;			//Forward
				PORTC.PODR.BIT.B6 =0 ;			//Forward
				step_r=step_l=0;			//step̏
				MTU.TSTR.BIT.CST3 = 1;			//^C}X^[g
				MTU.TSTR.BIT.CST4 = 1;			//^C}X^[g
				while( (step_r + step_l) < 954);

				x++;					//W1ɐi߂

			}else if(wall[x][y].south == NOWALL){
				//90mmi
				start_flag = 1;				//p
				PORTC.PODR.BIT.B5 =0 ;			//Forward
				PORTC.PODR.BIT.B6 =0 ;			//Forward
				step_r=step_l=0;			//step̏
				MTU.TSTR.BIT.CST3 = 1;			//^C}X^[g
				MTU.TSTR.BIT.CST4 = 1;			//^C}X^[g
				while( (step_r + step_l) < 477);
				MTU.TSTR.BIT.CST3 = 0;			//PWM~
				MTU.TSTR.BIT.CST4 = 0;			//PWM~

				//E90x
				start_flag = 0;				//pȂ
				for(k = 0; k < 1000000; k++ );		//OɊ[gȂȂ܂ł܂
				PORTC.PODR.BIT.B5 =1 ;			//Backward
				PORTC.PODR.BIT.B6 =0 ;			//Forward
				step_r=step_l=0;			//step̏
				MTU.TSTR.BIT.CST3 = 1;			//^C}X^[g
				MTU.TSTR.BIT.CST4 = 1;			//^C}X^[g
				while( (step_r + step_l) < 270);
				MTU.TSTR.BIT.CST3 = 0;			//PWM~
				MTU.TSTR.BIT.CST4 = 0;			//PWM~
				for(k = 0; k < 1000000; k++ );		//OɊ[gȂȂ܂ł܂

				//90mmi
				start_flag = 1;				//p
				PORTC.PODR.BIT.B5 =0 ;			//Forward
				PORTC.PODR.BIT.B6 =0 ;			//Forward
				step_r=step_l=0;			//step̏
				MTU.TSTR.BIT.CST3 = 1;			//^C}X^[g
				MTU.TSTR.BIT.CST4 = 1;			//^C}X^[g
				while( (step_r + step_l) < 477);

				y--;					//W1ɐi߂
				mydir=south;				//

				
			}else{
				//90mmi
				start_flag = 1;				//p
				PORTC.PODR.BIT.B5 =0 ;			//Forward
				PORTC.PODR.BIT.B6 =0 ;			//Forward
				step_r=step_l=0;			//step̏
				MTU.TSTR.BIT.CST3 = 1;			//^C}X^[g
				MTU.TSTR.BIT.CST4 = 1;			//^C}X^[g
				while( (step_r + step_l) < 477);
				MTU.TSTR.BIT.CST3 = 0;			//PWM~
				MTU.TSTR.BIT.CST4 = 0;			//PWM~
		
				//E180x
				start_flag = 0;				//pȂ
				for(k = 0; k < 1000000; k++ );		//OɊ[gȂȂ܂ł܂
				PORTC.PODR.BIT.B5 =1 ;			//Backward
				PORTC.PODR.BIT.B6 =0 ;			//Forward
				step_r=step_l=0;			//step̏
				MTU.TSTR.BIT.CST3 = 1;			//^C}X^[g
				MTU.TSTR.BIT.CST4 = 1;			//^C}X^[g
				while( (step_r + step_l) < 540);
				MTU.TSTR.BIT.CST3 = 0;			//PWM~
				MTU.TSTR.BIT.CST4 = 0;			//PWM~
				for(k = 0; k < 1000000; k++ );		//OɊ[gȂȂ܂ł܂

				//90mmi
				start_flag = 1;				//p
				PORTC.PODR.BIT.B5 =0 ;			//Forward
				PORTC.PODR.BIT.B6 =0 ;			//Forward
				step_r=step_l=0;			//step̏
				MTU.TSTR.BIT.CST3 = 1;			//^C}X^[g
				MTU.TSTR.BIT.CST4 = 1;			//^C}X^[g
				while( (step_r + step_l) < 477);

				x--;					//W1ɐi߂
				mydir=west;				//

			}
		}else if( mydir == south) {//is
			if( wall[x][y].east == NOWALL){
				//90mmi
				start_flag = 1;				//p
				PORTC.PODR.BIT.B5 =0 ;			//Forward
				PORTC.PODR.BIT.B6 =0 ;			//Forward
				step_r=step_l=0;			//step̏
				MTU.TSTR.BIT.CST3 = 1;			//^C}X^[g
				MTU.TSTR.BIT.CST4 = 1;			//^C}X^[g
				while( (step_r + step_l) < 477);
				MTU.TSTR.BIT.CST3 = 0;			//PWM~
				MTU.TSTR.BIT.CST4 = 0;			//PWM~
			
				//90x
				start_flag = 0;				//pȂ
				for(k = 0; k < 1000000; k++ );		//OɊ[gȂȂ܂ł܂
				PORTC.PODR.BIT.B5 =0 ;			//Forward
				PORTC.PODR.BIT.B6 =1 ;			//Backward
				step_r=step_l=0;			//step̏
				MTU.TSTR.BIT.CST3 = 1;			//^C}X^[g
				MTU.TSTR.BIT.CST4 = 1;			//^C}X^[g
				while( (step_r + step_l) < 270);
				MTU.TSTR.BIT.CST3 = 0;			//PWM~
				MTU.TSTR.BIT.CST4 = 0;			//PWM~
				for(k = 0; k < 1000000; k++ );		//OɊ[gȂȂ܂ł܂

				//90mmi
				start_flag = 1;				//p
				PORTC.PODR.BIT.B5 =0 ;			//Forward
				PORTC.PODR.BIT.B6 =0 ;			//Forward
				step_r=step_l=0;			//step̏
				MTU.TSTR.BIT.CST3 = 1;			//^C}X^[g
				MTU.TSTR.BIT.CST4 = 1;			//^C}X^[g
				while( (step_r + step_l) < 477);

				x++;					//W1ɐi߂
				mydir=east;				//
				
				
			}else if( wall[x][y].south == NOWALL){
				//180mmi
				start_flag = 1;				//p
				PORTC.PODR.BIT.B5 =0 ;			//Forward
				PORTC.PODR.BIT.B6 =0 ;			//Forward
				step_r=step_l=0;			//step̏
				MTU.TSTR.BIT.CST3 = 1;			//^C}X^[g
				MTU.TSTR.BIT.CST4 = 1;			//^C}X^[g
				while( (step_r + step_l) < 954);
			
				y--;					//W1ɐi߂
				
			}else if(wall[x][y].west == NOWALL){
				//90mmi
				start_flag = 1;				//p
				PORTC.PODR.BIT.B5 =0 ;			//Forward
				PORTC.PODR.BIT.B6 =0 ;			//Forward
				step_r=step_l=0;			//step̏
				MTU.TSTR.BIT.CST3 = 1;			//^C}X^[g
				MTU.TSTR.BIT.CST4 = 1;			//^C}X^[g
				while( (step_r + step_l) < 477);
				MTU.TSTR.BIT.CST3 = 0;			//PWM~
				MTU.TSTR.BIT.CST4 = 0;			//PWM~

				//E90x
				start_flag = 0;				//pȂ
				for(k = 0; k < 1000000; k++ );		//OɊ[gȂȂ܂ł܂
				PORTC.PODR.BIT.B5 =1 ;			//Bakward
				PORTC.PODR.BIT.B6 =0 ;			//Forward
				step_r=step_l=0;			//step̏
				MTU.TSTR.BIT.CST3 = 1;			//^C}X^[g
				MTU.TSTR.BIT.CST4 = 1;			//^C}X^[g
				while( (step_r + step_l) < 270);
				MTU.TSTR.BIT.CST3 = 0;			//PWM~
				MTU.TSTR.BIT.CST4 = 0;			//PWM~
				for(k = 0; k < 1000000; k++ );		//OɊ[gȂȂ܂ł܂

				//90mmi
				start_flag = 1;				//p
				PORTC.PODR.BIT.B5 =0 ;			//Forward
				PORTC.PODR.BIT.B6 =0 ;			//Forward
				step_r=step_l=0;			//step̏
				MTU.TSTR.BIT.CST3 = 1;			//^C}X^[g
				MTU.TSTR.BIT.CST4 = 1;			//^C}X^[g
				while( (step_r + step_l) < 477);

				x--;					//W1ɐi߂
				mydir=west;				//

				
			}else{
				//90mmi
				start_flag = 1;				//p
				PORTC.PODR.BIT.B5 =0 ;			//Forward
				PORTC.PODR.BIT.B6 =0 ;			//Forward
				step_r=step_l=0;			//step̏
				MTU.TSTR.BIT.CST3 = 1;			//^C}X^[g
				MTU.TSTR.BIT.CST4 = 1;			//^C}X^[g
				while( (step_r + step_l) < 477);
				MTU.TSTR.BIT.CST3 = 0;			//PWM~
				MTU.TSTR.BIT.CST4 = 0;			//PWM~
		
				//E180x
				start_flag = 0;				//pȂ
				for(k = 0; k < 1000000; k++ );		//OɊ[gȂȂ܂ł܂
				PORTC.PODR.BIT.B5 =1 ;			//Backward
				PORTC.PODR.BIT.B6 =0 ;			//Forward
				step_r=step_l=0;			//step̏
				MTU.TSTR.BIT.CST3 = 1;			//^C}X^[g
				MTU.TSTR.BIT.CST4 = 1;			//^C}X^[g
				while( (step_r + step_l) < 540);
				MTU.TSTR.BIT.CST3 = 0;			//PWM~
				MTU.TSTR.BIT.CST4 = 0;			//PWM~
				for(k = 0; k < 1000000; k++ );		//OɊ[gȂȂ܂ł܂

				//90mmi
				start_flag = 1;				//p
				PORTC.PODR.BIT.B5 =0 ;			//Forward
				PORTC.PODR.BIT.B6 =0 ;			//Forward
				step_r=step_l=0;			//step̏
				MTU.TSTR.BIT.CST3 = 1;			//^C}X^[g
				MTU.TSTR.BIT.CST4 = 1;			//^C}X^[g
				while( (step_r + step_l) < 477);

				y++;					//W1kɐi߂
				mydir=north;				//k
				
			}
		}else{//is͐
			if( wall[x][y].south == NOWALL){
				//90mmi
				start_flag = 1;				//p
				PORTC.PODR.BIT.B5 =0 ;			//Forward
				PORTC.PODR.BIT.B6 =0 ;			//Forward
				step_r=step_l=0;			//step̏
				MTU.TSTR.BIT.CST3 = 1;			//^C}X^[g
				MTU.TSTR.BIT.CST4 = 1;			//^C}X^[g
				while( (step_r + step_l) < 477);
				MTU.TSTR.BIT.CST3 = 0;			//PWM~
				MTU.TSTR.BIT.CST4 = 0;			//PWM~
			
				//90x
				start_flag = 0;				//pȂ
				for(k = 0; k < 1000000; k++ );		//OɊ[gȂȂ܂ł܂
				PORTC.PODR.BIT.B5 =0 ;			//Forward
				PORTC.PODR.BIT.B6 =1 ;			//Backward
				step_r=step_l=0;			//step̏
				MTU.TSTR.BIT.CST3 = 1;			//^C}X^[g
				MTU.TSTR.BIT.CST4 = 1;			//^C}X^[g
				while( (step_r + step_l) < 270);
				MTU.TSTR.BIT.CST3 = 0;			//PWM~
				MTU.TSTR.BIT.CST4 = 0;			//PWM~
				for(k = 0; k < 1000000; k++ );		//OɊ[gȂȂ܂ł܂

				//90mmi
				start_flag = 1;				//p
				PORTC.PODR.BIT.B5 =0 ;			//Forward
				PORTC.PODR.BIT.B6 =0 ;			//Forward
				step_r=step_l=0;			//step̏
				MTU.TSTR.BIT.CST3 = 1;			//^C}X^[g
				MTU.TSTR.BIT.CST4 = 1;			//^C}X^[g
				while( (step_r + step_l) < 477);

				y--;					//W1ɐi߂
				mydir=south;				//
				
				
			}else if( wall[x][y].west == NOWALL){
				//180mmi
				start_flag = 1;				//p
				PORTC.PODR.BIT.B5 =0 ;			//Forward
				PORTC.PODR.BIT.B6 =0 ;			//Forward
				step_r=step_l=0;			//step̏
				MTU.TSTR.BIT.CST3 = 1;			//^C}X^[g
				MTU.TSTR.BIT.CST4 = 1;			//^C}X^[g
				while( (step_r + step_l) < 954);

				x--;					//W1ɐi߂
				
			}else if(wall[x][y].north == NOWALL){
				//90mmi
				start_flag = 1;				//p
				PORTC.PODR.BIT.B5 =0 ;			//Forward
				PORTC.PODR.BIT.B6 =0 ;			//Forward
				step_r=step_l=0;			//step̏
				MTU.TSTR.BIT.CST3 = 1;			//^C}X^[g
				MTU.TSTR.BIT.CST4 = 1;			//^C}X^[g
				while( (step_r + step_l) < 477);
				MTU.TSTR.BIT.CST3 = 0;			//PWM~
				MTU.TSTR.BIT.CST4 = 0;			//PWM~

				//E90x
				start_flag = 0;				//pȂ
				for(k = 0; k < 1000000; k++ );		//OɊ[gȂȂ܂ł܂
				PORTC.PODR.BIT.B5 =1 ;			//Backward
				PORTC.PODR.BIT.B6 =0 ;			//Forward
				step_r=step_l=0;			//step̏
				MTU.TSTR.BIT.CST3 = 1;			//^C}X^[g
				MTU.TSTR.BIT.CST4 = 1;			//^C}X^[g
				while( (step_r + step_l) < 270);
				MTU.TSTR.BIT.CST3 = 0;			//PWM~
				MTU.TSTR.BIT.CST4 = 0;			//PWM~
				for(k = 0; k < 1000000; k++ );		//OɊ[gȂȂ܂ł܂

				//90mmi
				start_flag = 1;				//p
				PORTC.PODR.BIT.B5 =0 ;			//Forward
				PORTC.PODR.BIT.B6 =0 ;			//Forward
				step_r=step_l=0;			//step̏
				MTU.TSTR.BIT.CST3 = 1;			//^C}X^[g
				MTU.TSTR.BIT.CST4 = 1;			//^C}X^[g			
				while( (step_r + step_l) < 477);

				y++;					//W1kɐi߂
				mydir=north;				//k
				
			}else{
				//90mmi
				start_flag = 1;				//p
				PORTC.PODR.BIT.B5 =0 ;			//Forward
				PORTC.PODR.BIT.B6 =0 ;			//Forward
				step_r=step_l=0;			//step̏
				MTU.TSTR.BIT.CST3 = 1;			//^C}X^[g
				MTU.TSTR.BIT.CST4 = 1;			//^C}X^[g
				while( (step_r + step_l) < 477);
				MTU.TSTR.BIT.CST3 = 0;			//PWM~
				MTU.TSTR.BIT.CST4 = 0;			//PWM~
		
				//E180x
				start_flag = 0;				//pȂ
				for(k = 0; k < 1000000; k++ );		//OɊ[gȂȂ܂ł܂
				PORTC.PODR.BIT.B5 =1 ;			//Backward
				PORTC.PODR.BIT.B6 =0 ;			//Forward
				step_r=step_l=0;			//step̏
				MTU.TSTR.BIT.CST3 = 1;			//^C}X^[g
				MTU.TSTR.BIT.CST4 = 1;			//^C}X^[g
				while( (step_r + step_l) < 540);
				MTU.TSTR.BIT.CST3 = 0;			//PWM~
				MTU.TSTR.BIT.CST4 = 0;			//PWM~
				for(k = 0; k < 1000000; k++ );		//OɊ[gȂȂ܂ł܂

				//90mmi
				start_flag = 1;				//p
				PORTC.PODR.BIT.B5 =0 ;			//Forward
				PORTC.PODR.BIT.B6 =0 ;			//Forward
				step_r=step_l=0;			//step̏
				MTU.TSTR.BIT.CST3 = 1;			//^C}X^[g
				MTU.TSTR.BIT.CST4 = 1;			//^C}X^[g
				while( (step_r + step_l) < 477);

				x++;					//W1ɐi߂
				mydir=east;				//
				
			}
		}
	}//while end
	
	//ǂZbg
	wall_write[mydir] = ((fl_wall_ref > fl_sen) || (fr_wall_ref > fr_sen)) ? NOWALL: WALL;
	wall_write[(mydir+1)%4] = ((r_wall_ref+20)/2 > r_sen ) ? NOWALL : WALL ;
	wall_write[(mydir+2)%4] = NOWALL;
	wall_write[(mydir+3)%4] = ((l_wall_ref+20)/2 > l_sen ) ? NOWALL : WALL ;
	wall[x][y].north = wall_write[0];
	wall[x][y].east = wall_write[1];
	wall[x][y].south = wall_write[2];
	wall[x][y].west = wall_write[3];
	if(y < 15) wall[x][y+1].south = wall_write[0];
	if(x < 15) wall[x+1][y].west = wall_write[1];
	if(y > 0 ) wall[x][y-1].north = wall_write[2];
	if(x > 0 ) wall[x-1][y].east = wall_write[3];
	
	
//90mmi
	PORTC.PODR.BIT.B5 =0 ;			//Forward
	PORTC.PODR.BIT.B6 =0 ;			//Forward
	step_r=step_l=0;			//step̏
	MTU.TSTR.BIT.CST3 = 1;			//^C}X^[g
	MTU.TSTR.BIT.CST4 = 1;			//^C}X^[g
	while( (step_r + step_l) < 477);
	MTU.TSTR.BIT.CST3 = 0;			//PWM~
	MTU.TSTR.BIT.CST4 = 0;			//PWM~
	for(k = 0; k < 1000000; k++ );		//㎥؂OɊ[gȂȂ܂ł܂
	
	PORT1.PODR.BIT.B5 =0 ;			//Motor Power OFF
//TI	


	PORTA.PODR.BIT.B0 = 1;		//ELED3_
	PORTB.PODR.BIT.B0 = 1;		//LED0_	
//XCb`ꂽŒZs(S[ɓグāAd؂炸ɁAX^[gɂ)
	while(PORTC.PIDR.BIT.B3 == 1);	//^񒆂̃XCb`܂ő҂

	start_flag = 1;				//p
	PORT1.PODR.BIT.B5 =1 ;			//Motor Power ON
	for(k = 0; k < 1000000; k++ );		//㎥ł͈肵Ȃ̂ŏ҂
	
	
//
//	ŒZoHős
//
	
//}bv̏
	for(x = 0; x < 16; x++){		//H̑傫[v(xW)
		for(y = 0; y < 16; y++){	//H̑傫[v(yW)
			map[x][y] = 255;	//ׂ255Ŗ߂
		}
	}	
	map[3][3] = 0;				//S[W̕Oɐݒ

//}bv̍쐬
	do {
		change_flag = 0;
		for(x = 0; x < 16; x++) {
			for(y = 0; y < 16; y++) {
				if(map[x][y] == 255) {
					continue;
				}
				if( (wall[x][y].north) == NOWALL){
					if(map[x][y+1] == 255) {
					map[x][y+1] = map[x][y] + 1;
						change_flag = 1;
					}
				}
				if( (wall[x][y].east) == NOWALL){
					if(map[x+1][y] == 255) {
						map[x+1][y] = map[x][y] + 1;
						change_flag = 1;
					}
				}
				if( (wall[x][y].south) == NOWALL){
					if(map[x][y-1] == 255) {
						map[x][y-1] = map[x][y] + 1;
						change_flag = 1;
					}
				}
				if( (wall[x][y].west) == NOWALL){
					if(map[x-1][y] == 255){
						map[x-1][y] = map[x][y] + 1;
						change_flag = 1;
					}
				}
			}
		}
	}while(change_flag);	
	
	
	
//ƍW̏(X^[gn_X^[ĝōWƕ)
	mydir=north;
	x=0;
	y=0;
	
//90mmi
	PORTC.PODR.BIT.B5 =0 ;			//Forward
	PORTC.PODR.BIT.B6 =0 ;			//Forward
	step_r=step_l=0;			//step̏
	MTU.TSTR.BIT.CST3 = 1;			//^C}X^[g
	MTU.TSTR.BIT.CST4 = 1;			//^C}X^[g
	while( (step_r + step_l) < 477);

	y++;//90mmOɐi񂾂̂yW+1Z
	
	while( (x !=3 ) || (y !=3) ){

//iޕ߂
		little=255;
		if(wall[x][y].north == NOWALL){//k
			if(map[x][y+1] < little){
				little = map[x][y+1];
				next_dir = north;
			}
		}
		if(wall[x][y].east == NOWALL){//
			if(map[x+1][y] < little){
				little = map[x+1][y];
				next_dir = east;
			}
		}
		if(wall[x][y].south == NOWALL){//쑤
			if(map[x][y-1] < little){
				little = map[x][y-1];
				next_dir = south;
			}
		}
		if(wall[x][y].west == NOWALL){//
			if(map[x-1][y] < little){
				little = map[x-1][y];
				next_dir = west;
			}
		}
	
		switch( (4 + next_dir - mydir)%4){//next_dir:iޕ mydir:̕
			case 0 ://Oi
				//180mmi
				start_flag = 1;				//p
				PORTC.PODR.BIT.B5 =0 ;			//Forward
				PORTC.PODR.BIT.B6 =0 ;			//Forward
				step_r=step_l=0;			//step̏
				MTU.TSTR.BIT.CST3 = 1;			//^C}X^[g
				MTU.TSTR.BIT.CST4 = 1;			//^C}X^[g
				while( (step_r + step_l) < 954);
				break;
			case 1 ://EɋȂ
				//90mmi
				start_flag = 1;				//p
				PORTC.PODR.BIT.B5 =0 ;			//Forward
				PORTC.PODR.BIT.B6 =0 ;			//Forward
				step_r=step_l=0;			//step̏
				MTU.TSTR.BIT.CST3 = 1;			//^C}X^[g
				MTU.TSTR.BIT.CST4 = 1;			//^C}X^[g
				while( (step_r + step_l) < 477);
				MTU.TSTR.BIT.CST3 = 0;			//PWM~
				MTU.TSTR.BIT.CST4 = 0;			//PWM~

				//E90x
				start_flag = 0;				//pȂ
				for(k = 0; k < 1000000; k++ );		//OɊ[gȂȂ܂ł܂
				PORTC.PODR.BIT.B5 =1 ;			//Backward
				PORTC.PODR.BIT.B6 =0 ;			//Forward
				step_r=step_l=0;			//step̏
				MTU.TSTR.BIT.CST3 = 1;			//^C}X^[g
				MTU.TSTR.BIT.CST4 = 1;			//^C}X^[g
				while( (step_r + step_l) < 270);
				MTU.TSTR.BIT.CST3 = 0;			//PWM~
				MTU.TSTR.BIT.CST4 = 0;			//PWM~
				for(k = 0; k < 1000000; k++ );		//OɊ[gȂȂ܂ł܂

				//90mmi
				start_flag = 1;				//p
				PORTC.PODR.BIT.B5 =0 ;			//Forward
				PORTC.PODR.BIT.B6 =0 ;			//Forward
				step_r=step_l=0;			//step̏
				MTU.TSTR.BIT.CST3 = 1;			//^C}X^[g
				MTU.TSTR.BIT.CST4 = 1;			//^C}X^[g
				while( (step_r + step_l) < 477);
				
				break;
		
			default:
				//90mmi
				start_flag = 1;				//p
				PORTC.PODR.BIT.B5 =0 ;			//Forward
				PORTC.PODR.BIT.B6 =0 ;			//Forward
				step_r=step_l=0;			//step̏
				MTU.TSTR.BIT.CST3 = 1;			//^C}X^[g
				MTU.TSTR.BIT.CST4 = 1;			//^C}X^[g
				while( (step_r + step_l) < 477);
				MTU.TSTR.BIT.CST3 = 0;			//PWM~
				MTU.TSTR.BIT.CST4 = 0;			//PWM~
				
				//90x
				start_flag = 0;				//pȂ
				for(k = 0; k < 1000000; k++ );		//OɊ[gȂȂ܂ł܂
				PORTC.PODR.BIT.B5 =0 ;			//Forward
				PORTC.PODR.BIT.B6 =1 ;			//Backward
				step_r=step_l=0;			//step̏
				MTU.TSTR.BIT.CST3 = 1;			//^C}X^[g
				MTU.TSTR.BIT.CST4 = 1;			//^C}X^[g
				while( (step_r + step_l) < 270);
				MTU.TSTR.BIT.CST3 = 0;			//PWM~
				MTU.TSTR.BIT.CST4 = 0;			//PWM~
				for(k = 0; k < 1000000; k++ );		//OɊ[gȂȂ܂ł܂

				//90mmi
				start_flag = 1;				//p
				PORTC.PODR.BIT.B5 =0 ;			//Forward
				PORTC.PODR.BIT.B6 =0 ;			//Forward
				step_r=step_l=0;			//step̏
				MTU.TSTR.BIT.CST3 = 1;			//^C}X^[g
				MTU.TSTR.BIT.CST4 = 1;			//^C}X^[g
				while( (step_r + step_l) < 477);

				break;
		}
//ƍWXV
		mydir = next_dir;
	
		switch (next_dir){
			case north :
				y++;
				break;
			case east :
				x++;
				break;
			case south :
				y--;
				break;
			case west :
				x--;
				break;
		}
	}

	//90mmi
	PORTC.PODR.BIT.B5 =0 ;			//Forward
	PORTC.PODR.BIT.B6 =0 ;			//Forward
	step_r=step_l=0;			//step̏
	MTU.TSTR.BIT.CST3 = 1;			//^C}X^[g
	MTU.TSTR.BIT.CST4 = 1;			//^C}X^[g
	while( (step_r + step_l) < 477);
	MTU.TSTR.BIT.CST3 = 0;			//PWM~
	MTU.TSTR.BIT.CST4 = 0;			//PWM~
	for(k = 0; k < 1000000; k++ );		//㎥؂OɊ[gȂȂ܂ł܂

	
	PORT1.PODR.BIT.B5 =0 ;			//Motor Power OFF

	
	while(PORTC.PIDR.BIT.B3 == 1);	//^񒆂̃XCb`܂ő҂

	
//H16iŕ\
	while(SCI9_SEND_CHECK());
	SCI9_PRINTF("\n\r");
	
	for(y=15;y>-1;y--){
		for(x=0;x<16;x++){
			while(SCI9_SEND_CHECK());
			SCI9_PRINTF("%d%d%d%d ",wall[x][y].west, wall[x][y].south, wall[x][y].east, wall[x][y].north);
		}
		while(SCI9_SEND_CHECK());
		SCI9_PRINTF("\n\r");
	}
	while(1);//ƒ~
	
}

#ifdef __cplusplus
void abort(void)
{

}
#endif
